/*
Viral Loops v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package vloopapi

import (
	"encoding/json"
)

// checks if the EmailNotification type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &EmailNotification{}

// EmailNotification struct for EmailNotification
type EmailNotification struct {
	Subject string `json:"subject"`
	Body string `json:"body"`
	Footer string `json:"footer"`
}

// NewEmailNotification instantiates a new EmailNotification object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEmailNotification(subject string, body string, footer string) *EmailNotification {
	this := EmailNotification{}
	this.Subject = subject
	this.Body = body
	this.Footer = footer
	return &this
}

// NewEmailNotificationWithDefaults instantiates a new EmailNotification object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEmailNotificationWithDefaults() *EmailNotification {
	this := EmailNotification{}
	return &this
}

// GetSubject returns the Subject field value
func (o *EmailNotification) GetSubject() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Subject
}

// GetSubjectOk returns a tuple with the Subject field value
// and a boolean to check if the value has been set.
func (o *EmailNotification) GetSubjectOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Subject, true
}

// SetSubject sets field value
func (o *EmailNotification) SetSubject(v string) {
	o.Subject = v
}

// GetBody returns the Body field value
func (o *EmailNotification) GetBody() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Body
}

// GetBodyOk returns a tuple with the Body field value
// and a boolean to check if the value has been set.
func (o *EmailNotification) GetBodyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Body, true
}

// SetBody sets field value
func (o *EmailNotification) SetBody(v string) {
	o.Body = v
}

// GetFooter returns the Footer field value
func (o *EmailNotification) GetFooter() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Footer
}

// GetFooterOk returns a tuple with the Footer field value
// and a boolean to check if the value has been set.
func (o *EmailNotification) GetFooterOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Footer, true
}

// SetFooter sets field value
func (o *EmailNotification) SetFooter(v string) {
	o.Footer = v
}

func (o EmailNotification) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o EmailNotification) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["subject"] = o.Subject
	toSerialize["body"] = o.Body
	toSerialize["footer"] = o.Footer
	return toSerialize, nil
}

type NullableEmailNotification struct {
	value *EmailNotification
	isSet bool
}

func (v NullableEmailNotification) Get() *EmailNotification {
	return v.value
}

func (v *NullableEmailNotification) Set(val *EmailNotification) {
	v.value = val
	v.isSet = true
}

func (v NullableEmailNotification) IsSet() bool {
	return v.isSet
}

func (v *NullableEmailNotification) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEmailNotification(val *EmailNotification) *NullableEmailNotification {
	return &NullableEmailNotification{value: val, isSet: true}
}

func (v NullableEmailNotification) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEmailNotification) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


